//
// 地図表示
//

$(document).ready(function(){
	spot_map_initialize();
});

//
//地図の初期設定
//
function spot_map_initialize() {

	//
	//地図表示
	//
	var center = new google.maps.LatLng(34.3017690324184, 132.30306970000004);
	var zoom = 13;
	var spotsfile = "spots.php"; //spots.json or spots.php

	var mapOptions = {
		zoom: zoom,
		center: center,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		mapTypeControl: true,
		mapTypeControlOptions: {
			style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
		},
		navigationControl: true,
		navigationControlOptions: {
			style: google.maps.NavigationControlStyle.ZOOM_PAN
		},
		streetViewControl: false,
		scrollwheel: false
	};

	var map = new google.maps.Map($("#map_canvas").get(0), mapOptions);      

	//
	//マーカー表示
	//
	$.getJSON(spotsfile, function(spots){
		var markers = Array();
		//情報ウィンドウ（同時に１つだけ表示する）
		var infowindow = new google.maps.InfoWindow();

		var i;
		for (i=0; i<spots.length; i++) {
				//マーカーの追加
				markers[i] = new google.maps.Marker({
					position: new google.maps.LatLng(spots[i].lat, spots[i].lng),
					map: map,
					icon: spots[i].icon,
					title: spots[i].name,
					visible: true,
					info: spots[i]
				});

				//マーカーのクリック時の情報ウィンドウ表示
				markers[i].EventListenerMaps = google.maps.event.addListener(markers[i], 'click', function() {
					//内容
					var content = '<div style="width: 260px;height: 150px;">';
					content += '<span style="font-size: 120%;">'+this.info.name+'</span><br />';
					if (this.info.content != "");
						content += '<div>'+this.info.content+'</div>';
					if (this.info.image != "")
						content += '<img src="'+this.info.image+'" width="120" height="80" />';
					if (this.info.url != "")
						content += ' <a href="'+this.info.url+'" target="_blank">詳細を見る</a>';
					content += '</div>';

					//情報ウィンドウ表示
					infowindow.setContent(content);
					infowindow.open(this.getMap(), this);
				});
		}

	});


}
