<?php
/*
 機能 Google Map 向け JavaScript用JSON形式データを出力する。
 入力 CSV形式ファイル
 出力 JSON形式データをHTTP出力
*/

//PHP動作環境
mb_language("Japanese");
mb_internal_encoding("UTF-8");
mb_detect_order("auto");

//スポット一覧作成
$list = csvImport("spots.csv");

//JSONデータ作成
$json = json_encode($list);

//スポットデータ出力（JSON形式）
mb_http_output("pass");
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // 過去の日付
//header("Content-Type: text/javascript; charset=utf-8"); //IE8で動作不可のためコメント
print $json;

exit;

//
//ローカル関数
//
	/*
	 機能 CSVファイルを連想配列に読み込む
	 引数 $file
	 戻値 連想配列
	*/
	function csvImport($file) {
		$list = array();
		//ファイル読み込み
		$stream = mb_convert_encoding(file_get_contents($file), mb_internal_encoding(), mb_detect_order());
		$lines = explode("\n", $stream);

		//ヘッダ解析
		while ($line = array_shift($lines)) {
			if (substr($line, 0, 1)=='#' or $line=="") {
				continue; //#で始まる行、空行はスキップ
			}
			$header = csvParse($line);
			break;
		}
		if (!isset($header))
			return false;

		//データ解析
		foreach ($lines as $line) {
			if (substr($line, 0, 1)=='#' or $line=="") {
				continue; //#で始まる行、空行はスキップ
			}
			//データ設定
			$csv = csvParse($line);
			$cols = array();
			foreach ($csv as $col=>$data) {
				$cols[$header[$col]] = $data;
			}
			$list[] = $cols;
		}

		return $list;
	}

	/*
	 機能 CSVの１行を列データに分割する
	 引数 $line CSVの１行
	 戻値 添字配列
	*/
	function csvParse($line) {
		$line = preg_replace("/[\r\n]/", '', $line);
		preg_match_all('/("[^"]*(?:""[^"]*)*"|[^,]*),?/', $line, $col);
		foreach($col[1] as $key => $val) {
			if(preg_match('/^"(.*)"$/', $val, $matches)) {
				$col[1][$key] = preg_replace('/""/', '"', $matches[1]);
			}
		}
		array_pop($col[1]);
		return $col[1];
	}

?>
